<?php

class SaveDB extends Module
{
	private $dirAdminName;
	private $dbHost;
	private $dbUsername;
	private $dbPassword;
	private $dbDatabase;
	private $dbPrefix;
	private $dbResource;
	
	function __construct()
	{
		$this->name = 'savedb';
		$this->tab = 'DPFPIC - Modules';
		$this->version = 1.0;
		$this->author = 'DPFPIC';

		parent::__construct();

		/* The parent construct is required for translations */
		$this->page = basename(__FILE__, '.php');
		$this->displayName = $this->l('Save DB');
		$this->description = $this->l('Automatic save DB');
		$this->className = 'Backup';
		$this->dirAdminName = Configuration::get('DIR_ADMIN_NAME');
		
		$this->dbHost = _DB_SERVER_;
		$this->dbUsername = _DB_USER_;
		$this->dbPassword = _DB_PASSWD_;
		$this->dbDatabase = _DB_NAME_;
		self::dbConnect();
		
	}

	public function install()
	{
		if (!parent::install())
		return false;
		
		$base = explode( '/',$_SERVER['PHP_SELF']);
		$nameDir = $base[count($base) -2];	
		
		Configuration::updateValue('DIR_ADMIN_NAME', $nameDir);	
		Configuration::updateValue('TYPE_BACKUP', '1');
		
		return true;
	}
	
	public function uninstall()
	{
		return (parent::uninstall());			
	}

	/**
	* Open database connection
	*/
	private function dbConnect()
	{
		if($this->dbResource = @mysql_connect($this->dbHost, $this->dbUsername, $this->dbPassword))
		{
			if(!mysql_select_db($this->dbDatabase, $this->dbResource))
			{
				die(Tools::displayError('The database selection cannot be made.'));
			}
		}
		else
		{
			die(Tools::displayError('Link to database cannot be established.'));
		}
		mysql_query("SET NAMES 'utf8'", $this->dbResource);
		return $this->dbResource;
	}
	
	public function getContent() {
		global $token;
		$return = '<h2>'.$this->displayName.'</h2>';
		if (Tools::isSubmit('submitsettings'))
		{
			$type_backup = intval(Tools::getValue('type_backup'));
			Configuration::updateValue('TYPE_BACKUP', $type_backup);
			$return .= $this->displayConfirmation($this->l('Settings updated'));
		}
		if(Tools::isSubmit('Backup')):
		if(is_writable(realpath(dirname(__FILE__).'/../..').'/'.$this->dirAdminName.'/backups/'))
		{
			if (Configuration::get('TYPE_BACKUP') == 1) {
			$backup = $this->loadObject();
			if ($backup->add())
			{
				$return .= $this->displayConfirmation($this->l('Success backup'));
			}
			else {
				$return .= $this->displayError($this->l('Backup error'));
			}
			} else {
			if ($this->dumpSql() == 0)
			{
				$return .= $this->displayConfirmation($this->l('Success backup'));
			}
			else {
				$return .= $this->displayError($this->l('Backup error'));
			}
			}
			
		} else {
			$return .= $this->displayError($this->l('dir backups on admin dir must be writable (CHMOD 777)'));
		}	
		
		
		elseif(Tools::isSubmit('Delete')):
		$file = Tools::getValue('r');
		if(@unlink(realpath(dirname(__FILE__).'/../..').'/'.$this->dirAdminName.'/backups/'.$file)) {
			$return .= $this->displayConfirmation($this->l('Success deletion'));
		}
		else {
			$return .= $this->displayError($this->l('Error deletion'));
		}
		elseif(Tools::isSubmit('Download')):
		$file = Tools::getValue('r');
		$dwn = realpath(dirname(__FILE__).'/../..').'/'.$this->dirAdminName.'/backups/'.$file;

		if (!empty($file)) {
			$return .= $this->displayConfirmation($this->l('Success download'));
			header('Location: http://'.$_SERVER['SERVER_NAME'].__PS_BASE_URI__.$this->dirAdminName.DIRECTORY_SEPARATOR.'backup.php?filename='.$file);
		} else {
			$return .= $this->displayError($this->l('Error download'));
		}  
		endif;
		$return .= $this->displayForm();
		return $return;
	}

	public function loadObject($opt = false)
	{
		if ($id = Tools::getValue($this->identifier))
		return new $this->className($id);
		return new $this->className();
	}
	
	public function displayForm() {

		$return = '<fieldset>
				<legend><img src="'.$this->_path.'logo.gif" alt="" title="" />'.$this->l('Explanations').'</legend>
					<p>
					'.$this->l('Use the backup system of internal PrestaShop or use the "mysqldump" command of linux.').'
					<hr/>
					</p>
					<p>
					'.$this->l('"Server crontab" is the best method but only if your server uses Linux and you have access to crontab. In that case add the line below to your crontab file. See the wiki').'
					<a style="color: #38a822; text-decoration: underline;" href="http://fr.wikipedia.org/wiki/Crontab" target="_blank">Crontab</a>&nbsp;'.$this->l('usage explanations.').'
					'.$this->l('(For example every day at 3 AM).').'
					</p>
					<code>0 3 * * * php -f '.dirname(__FILE__).DIRECTORY_SEPARATOR.'cron.php</code>
					<hr/>
					<p>
					'.$this->l('"Webcron service" is a good alternative to crontab but is often not free. Register to a service like').' <a style="color: #38a822; text-decoration: underline;" href="http://www.setcronjob.com " target="_blank">setcronjob.com</a> 
					'.$this->l('and configure it to visit the URL below every day.').'
					</p>
					<code>http://'.$this->getHttpHost(false, true).$this->_path.'cron.php</code>

					</fieldset><div>&nbsp;</div>';
		$return .= '<form action="'.$_SERVER['REQUEST_URI'].'" method="post" name="formsettings">
				<fieldset>
				<legend><img src="'.$this->_path.'logo.gif" alt="" title="" />'.$this->l('Settings').'</legend>
				<label>'.$this->l('Method used for the backup').'</label>
				<div class="margin-form">
					<input type="radio" name="type_backup" id="type_backup_in" value="1" '.(Tools::getValue('type_backup', Configuration::get('TYPE_BACKUP')) ? 'checked="checked" ' : '').'/>
					<label class="t" for="type_backup_in"> '.$this->l('Internal').'</label>
					<input type="radio" name="type_backup" id="type_backup_ex" value="0" '.(!Tools::getValue('type_backup', Configuration::get('TYPE_BACKUP')) ? 'checked="checked" ' : '').'/>
					<label class="t" for="type_backup_ex"> '.$this->l('External').'</label>
					<p class="clear">'.$this->l('Internal : Use the internal backup PrestaShop').'</p>
					<p class="clear">'.$this->l('External : Use the command "mysqldump"').'</p>
				</div>
				<center><input type="submit" name="submitsettings" value="'.$this->l('Update').'" class="button" /></center>
				</fieldset><div>&nbsp;</div>';	
		$return .= '
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post" name="R">
			<fieldset>
				<legend><img src="'.$this->_path.'logo.gif" alt="" title="" />'.$this->l('Availables backups').'</legend>';
		$list = $this->makeSelect(self::copiesList());
		if ($list != '') {
			$return .= '
				<div style="margin-bottom: 10px;">
					<center>
			<select name="r" size="5" style="width:380px;">
				' . $list . '
			</select>
			</center>
				</div>
		<p align="center">
			<input type="submit" name="Download" value="'.$this->l('Download').'" class="button" />&nbsp;&nbsp;&nbsp;&nbsp;<input type="submit" name="Delete" value="'.$this->l('Delete').'" class="button" />
		</p>';
		}
		else {
			$return .= '<p align="center">' . $this->l('There is no backup.') . '</p>';
		}
		$return .= '
			</fieldset>
	</form>
			<div>&nbsp;</div>
	<form action="'.$_SERVER['REQUEST_URI'].'" method="post" name="B">
			<fieldset>
		<legend><img src="'.$this->_path.'logo.gif" alt="" title="" />'.$this->l('Make a backup now').'</legend>
		<center><input type="submit" name="Backup" value="'.$this->l('Make a backup now').'" class="button" /></center>
			</fieldset>
	</form>
			<div>&nbsp;</div>';
		$return .= '<fieldset>
					<legend>'.$this->l('About').'</legend>
					<p style="font-size: 1.5em; font-weight: bold; padding-bottom: 0"><img src="'.$this->_path.'logo.gif" alt="'.$this->displayName.'" style="float: left; padding-right: 1em"/>'.$this->displayName.'</p>
					<p style="clear: both">
					'.$this->description.'
					</p>
					<p>
					'.$this->l('Developped by').' <a style="color: #38a822; text-decoration: underline;" href="http://dpfpic.com" target="_blank">DPFPIC</a>
					</p>
				</fieldset><div>&nbsp;</div>';		
		return $return;
	}

	private function makeSelect($items, $itemSelected = '') {
		if(!is_array($items)):
		return false;
		endif;

		$return = '';
		foreach($items as $value=>$label):
		$selected = ($value == $itemSelected) ? ' selected="selected"' : ''; 
		$return .= "<option value=\"".$value."\"$selected>".$this->l($label)."</option>\n";
		endforeach;
		return $return;
	}

	private function copiesList() {
		$return = '';
		$files = scandir(realpath(dirname(__FILE__).'/../..').'/'.$this->dirAdminName.'/backups/');
		foreach(array_reverse($files) as $file)
		{
			if($file != '.' && $file != '..' && $file != 'index.php' && $file != '.htaccess')
			{
				$return[$file] = strftime('%d-%m-%Y - %H:%M',substr($file,0,11)).' - '.$file;
			}
		}
		return $return;
	}

	public function getHttpHost($http = false, $entities = false)
	{
		$host = (isset($_SERVER['HTTP_X_FORWARDED_HOST']) ? $_SERVER['HTTP_X_FORWARDED_HOST'] : $_SERVER['HTTP_HOST']);
		if ($entities)
		$host = htmlspecialchars($host, ENT_COMPAT, 'UTF-8');
		if ($http)
		$host = (Configuration::get('PS_SSL_ENABLED') ? 'https://' : 'http://').$host;
		return $host;
	}

	public function dumpSql() {
		// Generate some random number, to make it extra hard to guess backup file names
		$rand = dechex ( mt_rand(0, min(0xffffffff, mt_getrandmax() ) ) );
		$date = time();
		$backupFile = realpath(dirname(__FILE__).'/../..').'/'.$this->dirAdminName.'/backups/' . $date . '-' . $rand . '.sql.gz';
		$command = 'mysqldump --quick -h '.$this->dbHost.' -u '.$this->dbUsername.' -p'.$this->dbPassword.' '.$this->dbDatabase.' | gzip > '.$backupFile;
		system($command, $execut);
		return $execut;
	}	

	function cron() {
		/*$backupCron = $this->loadObject();
		if ($backupCron->add())
		{
			print('Backup success');
		}
		else
		{
			print('Error backup');
		}*/
		if ($this->dumpSql() == 0)
		{
			print('Backup success');
		}
		else
		{
			print('Error backup');
		}
	}
}
?>